<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Danh sách người dùng</title>

   <!-- Google Font: Source Sans Pro -->
   <link rel="stylesheet"
   href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">

  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  
 
</head>
<body class="hold-transition sidebar-mini layout-fixed">
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Orders list</a>
      </li>
    </ul>

    <!-- Right navbar links -->
    <ul class="navbar-nav ml-auto">
      <li class="nav-item">
        <a class="nav-link" data-widget="fullscreen" href="#" role="button">
          <i class="fas fa-expand-arrows-alt"></i>
        </a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index.html" class="brand-link">
      <span class="brand-text font-weight-light">Devcamp</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
               <li class="nav-item">
                <a href="index.html" class="nav-link">
                    <i class="nav-icon fas fa-th"></i>
                    <p>
                        Quản trị đơn hàng
                    </p>
                </a>
            </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Danh sách đơn hàng</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Orders list</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
        <div class="row">
          <div class="col-12">
            <button id="btn-create-order" class="btn btn-success"><i class="fas fa-plus"></i>&nbsp;Thêm mới</button>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="jumbotron">
          <div class="row">
            <div class="col-md-2">
              <label>Filter Loại Pizza</label>
            </div>
            <div class="col-md-4">
              <select name="" class="form-control" id="filter-select-pizza-type">
                <option value="all">All</option>
                <option value="Seafood">Hải sản</option>
                <option value="Hawaii">Hawaii</option>
                <option value="Bacon">Thịt hun khói</option>
              </select>
            </div>
            <div class="col-md-2">
              <label>Filter status:</label>
            </div>
            <div class="col-md-4">
              <select class="form-control" id="filter-select-status">
                <option value="all">All</option>
                <option value="open">Open</option>
                <option value="cancel">Đã hủy</option>
                <option value="confirmed">Đã xác nhận</option>
              </select>
            </div>
          </div>
        </div>
        <table id="orders-table" class="table table=striped table-bordered table-hover table-primary">
          <thead class="bg-primary">
              <tr>
                  <th>Order ID</th>
                  <th>Kich co combo</th>
                  <th>Loai pizza</th>
                  <th>Nước uống</th>
                  <th>Thành tiền</th>
                  <th>Họ và tên</th>
                  <th>Số điện thoại</th>
                  <th>Trạng thái</th>
                  <th>Actions</th>
              </tr>
          </thead>
          <tfoot>
            <tr>
              <th>Order ID</th>
              <th>Kich co combo</th>
              <th>Loai pizza</th>
              <th>Nước uống</th>
              <th>Thành tiền</th>
              <th>Họ và tên</th>
              <th>Số điện thoại</th>
              <th>Trạng thái</th>
              <th>Actions</th>
          </tr>
          </tfoot>
      </table>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.2.0
    </div>
  </footer>
     <!--Modal create orders-->
     <div class="modal fade" id="modal-create-order" tabindex="-1" role="dialog" aria-hidden="true">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">Thông tin đơn hàng(create)</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <form>
              <div class="form-group">
                  <label for="modal-select-combo" class="col-form-label">Kích cỡ combo</label>
                  <select class="form-control" id="modal-create-select-combo">
                      <option value="all">...Chọn kích cỡ Combo...</option>
                      <option value="S">S</option>
                      <option value="M">M</option>
                      <option value="L">L</option>
                  </select>
              </div>
              <div class="form-group">
                  <label for="modal-create-inp-duong-kinh" class="col-form-label">Đường kính pizza</label>
                  <input type="text" disabled class="form-control" id="modal-create-inp-duong-kinh">
              </div>
              <div class="form-group">
                  <label for="modal-create-inp-suon-nuong" class="col-form-label">Sườn nướng(Miếng)</label>
                  <input type="text" disabled class="form-control" id="modal-create-inp-suon-nuong">
              </div>
              <div class="form-group">
                <label for="modal-create-inp-salad" class="col-form-label">Salad(gr)</label>
                <input type="text" disabled class="form-control" id="modal-create-inp-salad">
              </div>
              <div class="form-group">
                <label for="modal-create-inp-drink" class="col-form-label">Số lượng nước uống</label>
                <input type="text" disabled class="form-control" id="modal-create-inp-drink">
            </div>
              <div class="form-group">
                <label for="modal-inp-price" class="col-form-label">Thành tiền</label>
                <input type="text" disabled class="form-control" id="modal-create-inp-price">
              </div>
              <div class="form-group">
                <label for="modal-create-inp-pizzatype" class="col-form-label">Loại Pizza(pizza type)</label>
                <select name="" class="form-control" id="modal-create-select-pizza-type">
                  <option value="all">..Chọn loại pizza..</option>
                  <option value="Seafood">Hải sản</option>
                  <option value="Hawaii">Hawaii</option>
                  <option value="Bacon">Thịt hun khói</option>
                </select>
            </div>
              <div class="form-group">
                  <label for="modal-create-select-drink" class="col-form-label">Đồ uống</label>
                  <select class="form-control" id="modal-create-select-drink">
                    <option value="all">Chọn đồ uống</option>
                  </select>
              </div>
              <div class="form-group">
                  <label for="modal-create-create-vourcherid" class="col-form-label">Vourcher ID(Mã vourcher)</label>
                  <input type="text" class="form-control" id="modal-create-input-vourcherid">
              </div>
              <div class="form-group">
                  <label for="modal-create-inp-fullname" class="col-form-label">Họ và tên</label>
                  <input type="text" class="form-control" id="modal-create-inp-fullname">
              </div>
              <div class="form-group">
                  <label for="modal-create-inp-email" class="col-form-label">Email</label>
                  <input type="text" class="form-control" id="modal-create-inp-email">
              </div>
              <div class="form-group">
                  <label for="modal-create-inp-phone-number" class="col-form-label">Số điện thoại</label>
                  <input type="text" class="form-control" id="modal-create-inp-phone-number">
              </div>
              <div class="form-group">
                  <label for="modal-create-inp-address" class="col-form-label">Địa chỉ</label>
                  <input type="text" class="form-control" id="modal-create-inp-address">
              </div>
              <div class="form-group">
                  <label for="modal-create-inp-subject" class="col-form-label">Lời nhắn</label>
                  <input type="text" class="form-control" id="modal-create-inp-subject">
              </div>
              <div class="form-group">
                  <label for="modal-create-inp-status" class="col-form-label">Trạng thái đơn hàng</label>
                  <select class="form-control" disabled id="modal-create-select-status">
                    <option value="open">open</option>
                    <option value="cancel">Đã hủy</option>
                    <option value="confirmed">Đã xác nhận</option>
                  </select>
              </div>
            </form>
          </div>
          <div class="modal-footer">
              <button id="modal-btn-create-confirm" type="button" class="btn btn-warning" data-dismiss="modal">Xác nhận</button>
              <button type="button" class="btn btn-danger" data-dismiss="modal">Hủy bỏ</button>
          </div>
        </div>
      </div>
    </div>
   <!--Modal update orders-->
  <div class="modal fade" id="modal-edit-order" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Thông tin đơn hàng(update)</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <form>
            <div class="form-group">
              <label for="modal-inp-orderid" class="col-form-label">Order ID(Mã đơn hàng)</label>
              <input type="text" disabled class="form-control" id="modal-edit-inp-orderid">
            </div>
            <div class="form-group">
                <label for="modal-select-combo" class="col-form-label">Cỡ combo</label>
                <select disabled class="form-control" id="modal-edit-select-combo">
                    <option value="S">Nhỏ</option>
                    <option value="M">Vừa</option>
                    <option value="L">Lớn</option>
                </select>
            </div>
            <div class="form-group">
                <label for="modal-edit-inp-duong-kinh" class="col-form-label">Đường kính pizza</label>
                <input type="text" disabled class="form-control" id="modal-edit-inp-duong-kinh">
            </div>
            <div class="form-group">
                <label for="modal-edit-inp-suon-nuong" class="col-form-label">Sườn nướng(Miếng)</label>
                <input type="text" disabled class="form-control" id="modal-edit-inp-suon-nuong">
            </div>
            <div class="form-group">
              <label for="modal-edit-inp-salad" class="col-form-label">Salad(gr)</label>
              <input type="text" disabled class="form-control" id="modal-edit-inp-salad">
            </div>
            <div class="form-group">
              <label for="modal-edit-inp-drink" class="col-form-label">Số lượng nước uống</label>
              <input type="text" disabled class="form-control" id="modal-edit-inp-drink">
            </div>
            <div class="form-group">
              <label for="modal-inp-price" class="col-form-label">Thành tiền</label>
              <input type="text" disabled class="form-control" id="modal-edit-inp-price">
            </div>
            <div class="form-group">
                <label for="modal-edit-select-drink" class="col-form-label">Đồ uống</label>
                <select class="form-control" disabled id="modal-edit-select-drink">
                  <option value="all">Chọn đồ uống</option>
                </select>
            </div>
            <div class="form-group">
              <label for="modal-edit-inp-pizzatype" class="col-form-label">Loại Pizza(pizza type)</label>
              <select class="form-control" disabled name="" id="modal-edit-select-pizza-type">
                <option value="Seafood">Hải sản</option>
                <option value="Hawaii">Hawaii</option>
                <option value="Bacon">Thịt hun khói</option>
              </select>
          </div>
            <div class="form-group">
                <label for="modal-edit-inp-vourcherid" class="col-form-label">Vourcher ID(Mã vourcher)</label>
                <input type="text" disabled class="form-control" id="modal-edit-inp-vourcherid">
            </div>
            <div class="form-group">
                <label for="modal-edit-inp-discount" class="col-form-label">Giảm giá(discount)</label>
                <input type="text" disabled class="form-control" id="modal-edit-inp-discount">
            </div>
            <div class="form-group">
                <label for="modal-edit-inp-fullname" class="col-form-label">Họ và tên</label>
                <input type="text" disabled class="form-control" id="modal-edit-inp-fullname">
            </div>
            <div class="form-group">
                <label for="modal-edit-inp-email" class="col-form-label">Email</label>
                <input type="text" disabled class="form-control" id="modal-edit-inp-email">
            </div>
            <div class="form-group">
                <label for="modal-edit-inp-phone-number" class="col-form-label">Số điện thoại</label>
                <input type="text" disabled class="form-control" id="modal-edit-inp-phone-number">
            </div>
            <div class="form-group">
                <label for="modal-edit-inp-address" class="col-form-label">Địa chỉ</label>
                <input type="text" disabled class="form-control" id="modal-edit-inp-address">
            </div>
            <div class="form-group">
                <label for="modal-edit-inp-subject" class="col-form-label">Lời nhắn</label>
                <input type="text" disabled class="form-control" id="modal-edit-inp-subject">
            </div>
            <div class="form-group">
              <label for="modal-edit-inp-status" class="col-form-label">Trạng thái đơn hàng</label>
              <select class="form-control" id="modal-edit-select-status">
                <option value="open">open</option>
                <option value="cancel">Đã hủy</option>
                <option value="confirmed">Đã xác nhận</option>
              </select>
          </div>
            <div class="form-group">
                <label for="modal-edit-inp-date-create" class="col-form-label">Ngày tạo đơn</label>
                <input type="text" disabled class="form-control" id="modal-edit-inp-date-create">
            </div>
            <div class="form-group">
                <label for="modal-edit-inp-date-update" class="col-form-label">ngày cập nhật</label>
                <input type="text" disabled class="form-control" id="modal-edit-inp-date-update">
            </div>
          </form>
        </div>
        <div class="modal-footer">
            <button id="modal-btn-edit-confirm" type="button" class="btn btn-success" data-dismiss="modal">Xác nhận</button>
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
        </div>
      </div>
    </div>
  </div>
  <!--Modal delete orders-->
  <div class="modal fade" tabindex="-1" id="modal-delete-order" role="dialog">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Xóa đơn hàng!</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <p>Bạn có chắc chắn muốn xóa đơn hàng này không?</p>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
          <button id="btn-modal-delete-order" type="button" data-dismiss="modal" class="btn btn-danger">Xóa đơn</button>
        </div>
      </div>
    </div>
  </div>
  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->
<!-- jQuery -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.js"></script>

<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</body>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gDRINK_URL = "http://203.171.20.210:8080/devcamp-pizza365/drinks"
  const gORDERS_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
  const gVOURCHER_URL =  "http://42.115.221.44:8080/devcamp-voucher-api/voucher_detail/";
  const gDATA_COLUMNS = ["orderCode","kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","chiTiet"];
  const gORDERID_COL = 0;
  const gKICH_CO_COL = 1;
  const gLOAI_PIZZA_COL = 2;
  const gID_NUOC_UONG_COL = 3;
  const gTHANH_TIEN_COL = 4;
  const gHO_TEN_COL = 5;
  const gSO_DIEN_THOAI_COL = 6;
  const gTRANG_THAI_COL = 7;
  const gCHI_TIET_COL = 8;
  var gId = "";
  var gOrdersData = {
    orderData: [],
    filterData:function(paramFilterObj){
      var vFilterResult = [];
      vFilterResult = this.orderData.filter(function(orderData){
        return(
          //Lọc mảng trang thải
          ((paramFilterObj.status === "all")||(orderData.trangThai!=null &&(orderData.trangThai.toLowerCase().includes(paramFilterObj.status.toLowerCase())))) &&
          //Lọc mảng pizza
          ((paramFilterObj.pizzaType === "all")||(orderData.loaiPizza!=null && (orderData.loaiPizza.toLowerCase().includes(paramFilterObj.pizzaType.toLowerCase()))))
        )
      })
      return vFilterResult;
    }
  }
  var gDiscount = 0;
  var gTable = $("#orders-table").DataTable({
      columns:[
          {data:gDATA_COLUMNS[gORDERID_COL]},
          {data:gDATA_COLUMNS[gKICH_CO_COL]},
          {data:gDATA_COLUMNS[gLOAI_PIZZA_COL]},
          {data:gDATA_COLUMNS[gID_NUOC_UONG_COL]},
          {data:gDATA_COLUMNS[gTHANH_TIEN_COL]},
          {data:gDATA_COLUMNS[gHO_TEN_COL]},
          {data:gDATA_COLUMNS[gSO_DIEN_THOAI_COL]},
          {data:gDATA_COLUMNS[gTRANG_THAI_COL]},
          {data:gDATA_COLUMNS[gCHI_TIET_COL]}
      ],
      columnDefs:[
          {
              targets:gCHI_TIET_COL,
              render:function(data,type,row,meta){
                  return`<i id="btn-edit" class="fas fa-edit fa-lg" data-orderid="${row.orderCode}" style="color:SpringGreen;cursor: pointer;"></i>&nbsp;<i id="btn-delete" class="far fa-trash-alt fa-lg" data-id="${row.id}" style="color:Tomato;cursor: pointer;"></i>`
              }
          }
      ]
  })
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function(){
      "use strict";
      //Gọi ajax lấy thông tin order
      callAjaxGetOrderDetail();
      //Gọi ajax lấy thông tin nước uống
      callAjaxGetDrinkLIst();
  })
  //Jquery tạo event handler cho nút thêm mới
  $("#btn-create-order").on("click",onBtnCreateOrderClick);
  //Jquery tạo event handler cho nút xác nhận tạo đơn
  $("#modal-btn-create-confirm").on("click",onBtnModalCreateOrderClick)
  //Jquery tạo event handler cho nút sửa đơn
  $("#orders-table").on("click","#btn-edit",onBtnUpdateOrdersClick);
  //Jquery tạo event handler cho nút confirm
  $("#modal-btn-edit-confirm").on("click",onModalBtnConFirmClick);
  //Jquery tạo event handler cho nút xóa đơn
  $("#orders-table").on("click","#btn-delete",onBtnDeleteOrderClick);
  //Jquery tạo event handler cho nút xóa đơn
  $("#btn-modal-delete-order").on("click",onModalBtnDeleteOrderClick);
  //Jquery tạo event hnadler "change" cho select kích cỡ
  $("#modal-create-select-combo").on("change",onChangeselectSizeCombo);
  //Jquery tạo event hnadler "change" cho select filter loại pizza
  $("#filter-select-pizza-type").on("change",onChangeselectPizzaType);
  //Jquery tạo event hnadler "change" cho select filter trạng thái
  $("#filter-select-status").on("change",onChangeselectStatusType);
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
   //Hàm xử lý sự kiện khi "change" trạng thái
   function onChangeselectStatusType(){
    "use strict";
    //B1:Tạo hướng đối tượng và thu thập dữ liệu
    var vSelectedData = {
      pizzaType:"",
      status:""
    }
    //Thu thập dữ liệu của ô select filter
    getDaTaFormSelectFilter(vSelectedData);
    //B2:Kiểm tra dữ liệu(bỏ qua)

    //B3:filterData(lọc dữ liệu) từ dữ liệu vừa thu thập
    var vFilterData = gOrdersData.filterData(vSelectedData);
    //B4:Hiển thị lên dataTaable
    displayDataToTable(vFilterData);
  }
  //Hàm xử lý sự kiện khi "change" loại pizza
  function onChangeselectPizzaType(){
    "use strict";
    //B1:Tạo hướng đối tượng và thu thập dữ liệu
    var vSelectedData = {
      pizzaType:"",
      status:""
    }
    //Thu thập dữ liệu của ô select filter
    getDaTaFormSelectFilter(vSelectedData);
    //B2:Kiểm tra dữ liệu(bỏ qua)

    //B3:filterData(lọc dữ liệu) từ dữ liệu vừa thu thập
    var vFilterData = gOrdersData.filterData(vSelectedData);
    //B4:Hiển thị lên dataTaable
    displayDataToTable(vFilterData);
  }
  //Hàm xử lý tạo sự kiện cho nút xác nhận tạo mới order
  function onBtnModalCreateOrderClick(){
    "use strict";
    //B1:Tạo hướng đối tượng và thu thập thông tin
    var vObjectRequest = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVourcher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        thanhTien: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: "",
        trangThai:"",
        giamGia:0
    }
    //Thu thập thông tin từ modal
    getDataFormModalCreate(vObjectRequest);
    console.log(vObjectRequest);
    //B2:Kiểm tra dữ liệu
    var vCheck = validateDataFoemModal(vObjectRequest);
    var vEmailCheck = validateEmailDataFoemModal(vObjectRequest.email);
    if ( vCheck == vEmailCheck) {
      //B3:Gọi ajax
      //Gọi ajax lấy phần trăm giảm giá
      callAjaxGetDiscountByVourcherId(vObjectRequest.idVourcher);
      vObjectRequest.giamGia = getActualPriceDisCount(gDiscount ,vObjectRequest.thanhTien);
      //console.log(vObjectRequest);
      //Gọi ajax thêm mới dữ liệu order
      callAjaxCreateOrder(vObjectRequest);
    }
  }
  //Hàm xử lý tạo sự kiện cho nút thêm mới order
  function onBtnCreateOrderClick(){
    "use strict";
    //reset lại modal create
    resetModalCreateOrder();
    $("#modal-create-order").modal("show");
  }
  //Hàm xử lý sự kiện khi thay đổi của ô select combo
  function onChangeselectSizeCombo(){
    "use strict";
    //lấy thông tin combo lưu vào biến
    var vCombo = $(this).val();
    //Hiển thị dữ liệu combo dựa vào tên combo
    displayComboDataToModalInput(vCombo);
  }
  //Hàm xử lý sự kiện khi nhắn nút xóa đơn trên modal
  function onModalBtnDeleteOrderClick(){
    "use strict";
    //Gọi ajax để xóa đơn
    callAjaxDeleteOrder();
  }
  //hàm sữ lý sự kiện khi ắn nút xóa
  function onBtnDeleteOrderClick(){
    "use strict";
    var vId = $(this).data("id");
    gId = vId;
    $("#modal-delete-order").modal("show");
  }
  //hàm sữ lý sự kiện khi ắn nút sửa
  function onBtnUpdateOrdersClick(){
      "use strict";
      var vOrderId = $(this).data("orderid");
      //Lấy thông tin dựa vào orderId
      var vOrderData = filterDataByOrderId(vOrderId);
      gId = vOrderData[0].id;
      //console.log(vOrderData)
      //Hiển thị dũ liệu ra modal
      displayDatatoModalUpdate(vOrderData[0])
      $("#modal-edit-order").modal("show");
  } 
  //hàm sữ lý sự kiện khi ắn nút confirm
  function onModalBtnConFirmClick(){
      "use strict";
      var vObjectRequest = {
        trangThai:"" 
    } 
    vObjectRequest.trangThai = $("#modal-edit-select-status").val();

    //Gọi ajax cập nhật trạng thái của đơn hàng
    callAjaxUpdateStatusOrder(vObjectRequest);
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //Hàm thu thập dữ liệu từ ô select filter
  function getDaTaFormSelectFilter(paramData){
    "use strict";
    paramData.pizzaType = $("#filter-select-pizza-type").val();
    paramData.status = $("#filter-select-status").val();
  }
  //Hàm reset lại modal create
  function resetModalCreateOrder(){
    "use strict";
   $("#modal-create-select-combo").val("all");
    $("#modal-create-inp-duong-kinh").val("");
    $("#modal-create-inp-suon-nuong").val("");
    $("#modal-create-inp-salad").val("");
    $("#modal-create-inp-drink").val("");
    $("#modal-create-inp-price").val("");
    $("#modal-create-input-vourcherid").val("");
    $("#modal-create-select-drink").val("all");
    $("#modal-create-select-pizza-type").val("all");
    $("#modal-create-inp-fullname").val("");
    $("#modal-create-inp-email").val("");
    $("#modal-create-inp-phone-number").val("");
    $("#modal-create-inp-address").val("");
    $("#modal-create-inp-subject").val("");
  }
  //Hàm gọi ajax thêm mới dữ liệu order
  function callAjaxCreateOrder(paramData){
    "use strict";
    $.ajax({
      url:gORDERS_URL,
      type:"POST",
      contentType:"application/json",
      data:JSON.stringify(paramData),
      success:function(responseObject){
        alert("Thêm mới order thành công:\n" + JSON.stringify(responseObject))
      },
      error:function(ajaxContext){
        alert(ajaxContext.responseText);
      }
    })
  }
  //Hàm tính số tiền được giảm dựa vào giá tiền
  function getActualPriceDisCount(paramDiscount , paramPrice){
    "use strict";
    return (paramPrice*paramDiscount/100);
  }
  //Hàm gọi ajax lấy phần trăm giảm giá
  function callAjaxGetDiscountByVourcherId(paramVourcher){
    "use strict";
    $.ajax({
      url:gVOURCHER_URL + paramVourcher,
      type:"GET",
      dataType:"json",
      async:false,
      success:function(responseObject){
        //console.log( responseObject.phanTramGiamGia);
        gDiscount = responseObject.phanTramGiamGia;
      }
    })
  }
  //Hàm kiểm tra email
  function validateEmailDataFoemModal(paramEmail){
    "use strict";
    var vResult = true;
    if ( paramEmail != "" && !paramEmail.includes(".") && (!paramEmail.includes("@")|| paramEmail.startsWith("@")|| !paramEmail.endsWith("@") )) {
    alert("Email không đúng định dạng!");
    vResult = false;
    }
    return vResult;
  }
  //Hàm kiểm tra dữ liệu
  function validateDataFoemModal (paramData){
    "use strict";
    var vResult = true;
    var vKichCo = paramData.kichCo;
    var vLoaiPizza = paramData.loaiPizza;
    var vIdvourcher = paramData.idVourcher.trim();
    var vIdNuocUong = paramData.idLoaiNuocUong;
    var vHoTen = paramData.hoTen.trim();
    var vSoDienThoai = paramData.soDienThoai.trim();
    var vDiaChi = paramData.diaChi.trim();
    if(vKichCo == "all"){
      alert("Hãy chọn kích cỡ combo!");
      vResult = false;
    } else if(vLoaiPizza == "all"){
      alert("Hãy chọn loại pizza!");
      vResult = false;
    } else if(vIdNuocUong == "all"){
      alert("Hãy chọn loại nước uống!");
      vResult = false;
    } else if(isNaN(vIdvourcher)){
      alert("Id vourcher phải là số!");
      vResult = false;
    } else if(vHoTen == ""){
      alert("Hãy nhập họ tên");
      vResult = false;
    } else if(vSoDienThoai == "" || isNaN(vSoDienThoai)){
      alert("Sô điện thoại không được rỗng hoặc phải là số!");
      vResult = false;
    } else if(vDiaChi == "" ){
      alert("Hãy nhập địa chỉ");
      vResult = false;
    }
    return vResult;
  }
  //Hàm thu thập thông tin từ modal create
  function getDataFormModalCreate(paramData){
    "use strict";
      paramData.kichCo = $("#modal-create-select-combo").val();
      paramData.duongKinh = $("#modal-create-inp-duong-kinh").val();
      paramData.suon = $("#modal-create-inp-suon-nuong").val();
      paramData.salad = $("#modal-create-inp-salad").val();
      paramData.soLuongNuoc = $("#modal-create-inp-drink").val();
      paramData.thanhTien = $("#modal-create-inp-price").val();
      paramData.idVourcher = $("#modal-create-input-vourcherid").val();
      paramData.idLoaiNuocUong = $("#modal-create-select-drink").val();
      paramData.loaiPizza = $("#modal-create-select-pizza-type").val();
      paramData.hoTen = $("#modal-create-inp-fullname").val();
      paramData.email = $("#modal-create-inp-email").val();
      paramData.soDienThoai = $("#modal-create-inp-phone-number").val();
      paramData.diaChi = $("#modal-create-inp-address").val();
      paramData.loiNhan = $("#modal-create-inp-subject").val();
      paramData.trangThai = $("#modal-create-select-status").val();
    }
  //Hàm hiển thị dữ liệu combo dựa vào tên combo
  function displayComboDataToModalInput(paramCombo){
    "use strict";
    if(paramCombo == "all"){
      $("#modal-create-inp-duong-kinh").val("");
      $("#modal-create-inp-suon-nuong").val("");
      $("#modal-create-inp-salad").val("");
      $("#modal-create-inp-drink").val("");
      $("#modal-create-inp-price").val("");
    } else if(paramCombo == "S"){
      $("#modal-create-inp-duong-kinh").val(20);
      $("#modal-create-inp-suon-nuong").val(2);
      $("#modal-create-inp-salad").val(200);
      $("#modal-create-inp-drink").val(2);
      $("#modal-create-inp-price").val(150000);
    } else if(paramCombo == "M"){
      $("#modal-create-inp-duong-kinh").val(25);
      $("#modal-create-inp-suon-nuong").val(4);
      $("#modal-create-inp-salad").val(300);
      $("#modal-create-inp-drink").val(3);
      $("#modal-create-inp-price").val(200000);
    } else if(paramCombo == "L"){
      $("#modal-create-inp-duong-kinh").val(30);
      $("#modal-create-inp-suon-nuong").val(8);
      $("#modal-create-inp-salad").val(500);
      $("#modal-create-inp-drink").val(4);
      $("#modal-create-inp-price").val(250000);
    }
  }
  //Hàm gọi ajax để thưc hiện xóa đơn
  function callAjaxDeleteOrder(){
    "use strict";
    $.ajax({
      url:gORDERS_URL + "/" + gId,
      type:"DELETE",
      dataType:"json",
      success:function(){
        alert("Xóa thành công order có id là: " + gId);
        callAjaxGetOrderDetail();
      },
      error:function(ajaxContext){
        alert(ajaxContext.responseText);
      }
    })
  }
  //Hàm gọi ajax cập nhật trạng thái của đơn hàng
  function callAjaxUpdateStatusOrder(paramData){
      "use strict";
      $.ajax({
          url:gORDERS_URL + "/" + gId,
          type:"PUT",
          contentType:"application/json",
          data:JSON.stringify(paramData),
          success:function(responseObject){
              alert("Cập nhật thành công trạng thái "+ paramData.trangThai + "cho đơn hàng: \n" + JSON.stringify(responseObject));
              callAjaxGetOrderDetail();
          },
          error:function(ajaxContext){
              alert(ajaxContext.responseText);
          }
      })
  }
  //Hàm hiển thị dũ liệu ra modal update
  function displayDatatoModalUpdate(paramData){
      "use strict";
      $("#modal-edit-inp-orderid").val(paramData.orderId);
      $("#modal-edit-select-combo").val(paramData.kichCo);
      $("#modal-edit-inp-duong-kinh").val(paramData.duongKinh);
      $("#modal-edit-inp-suon-nuong").val(paramData.suon);
      $("#modal-edit-select-drink").val(paramData.idLoaiNuocUong);
      $("#modal-edit-inp-drink").val(paramData.soLuongNuoc);
      $("#modal-edit-inp-vourcherid").val(paramData.idVourcher);
      $("#modal-edit-select-pizza-type").val((paramData.loaiPizza));
      $("#modal-edit-inp-salad").val(paramData.salad);
      $("#modal-edit-inp-price").val(paramData.thanhTien);
      $("#modal-edit-inp-discount").val(paramData.giamGia);
      $("#modal-edit-inp-fullname").val(paramData.hoTen);
      $("#modal-edit-inp-email").val(paramData.email);
      $("#modal-edit-inp-phone-number").val(paramData.soDienThoai);
      $("#modal-edit-inp-address").val(paramData.diaChi);
      $("#modal-edit-inp-subject").val(paramData.loiNhan);
      $("#modal-edit-select-status").val(paramData.trangThai);
      $("#modal-edit-inp-date-create").val(paramData.ngayTao);
      $("#modal-edit-inp-date-update").val(paramData.ngayCapNhat);
  }
  //Hàm lấy thông tin dựa vảo orderId
  function filterDataByOrderId(paramOrderId){
      "use strict";
     var vFilterData = gOrdersData.orderData.filter(function(order){
      return order.orderCode == paramOrderId
     })
     return vFilterData;
  }
  //Hàm hiển thị thông tin đò uống lên modal
  function displayToModalDrinkSelect(paramData){
      "use stroct"
      $.each(paramData,function(key,value){
          $("#modal-edit-select-drink").append($("<option>",{
              text:value.tenNuocUong,
              value:value.maNuocUong
          }))
          $("#modal-create-select-drink").append($("<option>",{
              text:value.tenNuocUong,
              value:value.maNuocUong
          }))
      })
  }
  //Hàm gọi ajax lấy thông tin nước uống
  function callAjaxGetDrinkLIst(){
      "use strict";
      $.ajax({
      url:gDRINK_URL,
      type:"GET",
      dataType:"json",
      success:function(responseObject){
          //console.log(responseObject);
          displayToModalDrinkSelect(responseObject)
      },
      error:function(ajaxContext){
          alert(ajaxContext.responseText);
      }
      })
  }
  //Hàm hiển thị thông tin lên table
  function displayDataToTable(paramData){
      "use strict";
      gTable.clear();
      gTable.rows.add(paramData);
      gTable.draw();
  }
  //Hàm gọi ajax lấy thông tin order
  function callAjaxGetOrderDetail(){
      "use strict";
      $.ajax({
          url: gORDERS_URL,
          type:"GET",
          dataType:"json",
          success:function(responseObject){
              //Hiển thị thông tin lên table
              gOrdersData.orderData = responseObject;
              displayDataToTable(responseObject)
          },
          error:function(ajaxContext){
              alert(ajaxContext.responseText);
          }
      })
  }
</script>
</html>
